import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';
import { CreatePlayer } from '../models/create-player';
import { Player } from '../models/player';
import { Team } from '../models/team';

@Injectable({
  providedIn: 'root'
})
export class PlayerService {

  freePlayers: Player[] = [
    {id: 4, name: "Bobby Orr"},
    {id: 5, name: "Wayne Gretzky"},
    {id: 6, name: "Denis Potvin"}
  ];

  players: Player[] = [
    {id: 1, name: "Sidney Cosby"},
    {id: 2, name: "Alexander Ovechkin"},
    {id: 3, name: "Gordie Howe"},
    {id: 4, name: "Bobby Orr"},
    {id: 5, name: "Wayne Gretzky"},
    {id: 6, name: "Denis Potvin"}
  ];

  teamOnePlayers: Player[] = [
    {id: 1, name: "Sidney Cosby"},
    {id: 2, name: "Alexander Ovechkin"},
  ];

  constructor() { }

  getPlayers() : Observable<Player[]> {
    return of(this.players);
  }

  getFreePlayers() : Observable<Player[]> {
    return of(this.freePlayers);
  }

  getPlayersForTeam(id: number) : Observable<Player[]> {
    if (id === 1) {
      return of(this.teamOnePlayers);
    } else {
      return of([]);
    }
  }

  recruitPlayer(player: CreatePlayer, team: Team) : void {
    if(team.id == 1) {
      this.teamOnePlayers.push({
        name: player.name,
        id: Math.random()
      });
    }
  }

  recruitVeteranPlayer(player: Player, team: Team) : void {
    if(team.id == 1) {
      this.teamOnePlayers.push(player);
      this.freePlayers = this.freePlayers.filter((val, i, array) => val.id != player.id);
    }
  }

  firePlayer(id: number): void {
    let player: Player|undefined = this.teamOnePlayers.find((val) => val.id == id);
    if ( player != undefined ) {
      this.freePlayers.push(
        player
      )
    }
    this.teamOnePlayers = this.teamOnePlayers
      .filter((val, i, array) => val.id != id);
  }
}
